#!/bin/sh

# to allow core dumps
ulimit -c unlimited


if [ -z "$1" ] || [ -z "$2" ] || ( [ "$2" != "0" ] && [ "$2" != "3" ] ); then
		echo "usage: solve.boolector.sh <smt2_file> 0|3"
		exit
fi

file=$1


echo "$1    with    -rwl$2:"


if [ $2 = "3" ]; then
	echo "Boolector generates BTOR..."
	_boolector/boolector $file -de -o $file.0.btor -rwl$2
	
	echo "Boolector dumps SMT2..."
	_boolector/boolector-dev $file.0.btor --dump-smt2 -o $file.3.smt2
fi


start=$(date +%s.%N)
echo "Boolector solves SMT2..."
if [ $2 = "0" ]; then
	_boolector/boolector $file -t 600 -rwl0
else
	_boolector/boolector $file.3.smt2 -t 600 -rwl3
fi
end=$(date +%s.%N)
printf "Runtime:    %.1f s\n"  $(echo "$end - $start"|bc )
