#!/bin/sh

# to allow core dumps
ulimit -c unlimited


if [ -z "$1" ] || [ -z "$2" ] || ( [ "$2" != "0" ] && [ "$2" != "3" ] ) || ( [ -n "$3" ] && [ "$3" != "solve" ] ); then
		echo "usage: solve.bv2epr.sh <smt2_file> 0|3 [solve]"
		exit
fi

file=$1


echo "$1    with    -rwl$2:"


if [ $2 = "3" ]; then
	echo "Boolector generates BTOR..."
	_boolector/boolector $file -de -o $file.3.btor -rwl3
	
	echo "Boolector dumps SMT2..."
	_boolector/boolector-dev $file.3.btor --dump-smt2 -o $file.3.smt2
	
	file=$file.3.smt2
fi


start=$(date +%s.%N)

echo "Bv2Epr generates EPR..."
_bv2epr/bv2epr $file -o $file.$2.p -rwl3 -v
end=$(date +%s.%N)
echo -n "Bv2Epr generated EPR..."
printf "\t%.1fs passed\n"  $(echo "$end - $start"|bc )

if [ -n "$3" ]; then
	echo "iProver solves EPR..."
	_bv2epr/iproveropt_v0.8.1_linux64 --time_out_real 600 --out_options none --sat_out_model none --schedule verification_epr --resolution_flag false --inst_prop_sim_given true $file.$2.p
#	_bv2epr/iproveropt_v0.99 --time_out_real 600 --out_options none --sat_out_model none --inst_out_proof false --schedule verification_epr --resolution_flag false --bmc1_incremental false --inst_prop_sim_given true $file.$2.p
fi

end=$(date +%s.%N)
printf "Runtime:    %.1f s\n"  $(echo "$end - $start"|bc )
