#/bin/sh

# to allow core dumps
ulimit -c unlimited


if [ -z "$1" ] || [ -z "$2" ] || ( [ "$2" != "0" ] && [ "$2" != "3" ] ) || ( [ -n "$3" ] && [ "$3" != "solve" ] ); then
		echo "usage: solve.synthebtor.sh <smt2_file> 0|3 [solve]"
		exit
fi

file=$1


echo "$1    with    -rwl$2:"


if [ $2 = "0" ]; then
	start=$(date +%s.%N)
fi

echo "Boolector generates BTOR..."
_boolector/boolector $file -de -o $file.$2.btor -rwl$2

if [ $2 = "3" ]; then
	echo "Boolector dumps SMT2..."
	_boolector/boolector-dev $file.3.btor --dump-smt2 -o $file.3.smt2

	start=$(date +%s.%N)
	echo "Boolector generates BTOR..."
	_boolector/boolector $file.3.smt2 -de -o $file.3.btor -rwl$2
fi

file=$file.$2


echo -n "Synthebtor generates AIG..."
_boolector/synthebtor -m -rwl$2 $file.btor $file.aig
end=$(date +%s.%N)
printf "\t%.1fs passed\n"  $(echo "$end - $start"|bc )

echo -n "AigToCnf generates CNF..."
_boolector/aigtocnf $file.aig $file.cnf
end=$(date +%s.%N)
printf "\t%.1fs passed\n"  $(echo "$end - $start"|bc )

if [ -n "$3" ]; then
	echo "Lingeling solves CNF..."
	_boolector/lingeling -n -t 600 $file.cnf
fi
end=$(date +%s.%N)
printf "Runtime:    %.1f s\n"  $(echo "$end - $start"|bc )
